/*
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of he MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 * 
 * This Source Code is part of the More-CPP CORE library.
 * https://www.more-cpp.com
 */
#include "../resources/manager.h"
#include "../threads/jobs/manager.h"
#include "../threads/pool/manager.h"

#include "singleton_manager.h"

INITIALIZE_SINGLETON(core_arch_singleton_manager_t);

extern "C" DLLEXPORT core_arch_singleton_manager_t* get_singleton_manager(void)
{
	return core_arch_singleton_manager_t::instance;
}

// cleanup to avoid deadlocks
extern "C" void DLLEXPORT cleanup(void)
{
	core::get_instance<core_resources_manager_t>()->stop();
	core::get_instance<core_threads_jobs_manager_t>()->stop();
	core::get_instance<core_threads_pool_manager_t>()->reset();
}