/*
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 * 
 * This Source Code is part of the More-CPP CORE library.
 * https://www.more-cpp.com
 */
#pragma once

#include "../../utils/utils.h"

#include "../../exception.h"

#include <string>

/* invalid_instancer_callback_exception exception class */
class invalid_instancer_callback_exception : public core_exception_base_t
{
public:
	invalid_instancer_callback_exception(const std::string& name)
	{
		this->m_name = name;
	}

	virtual std::string to_string(void) const override
	{
		return std::string("No valid instancer function for type \"") + this->m_name + std::string("\"!");
	}

private:
	std::string m_name;
};

/* unknown_instancer_exception exception class */
class unknown_instancer_exception : public core_exception_base_t
{
public:
	unknown_instancer_exception(const std::string& name)
	{
		this->m_name = name;
	}

	virtual std::string to_string(void) const override
	{
		return std::string("Unknown instancer \"") + this->m_name + std::string("\"!");
	}

private:
	std::string m_name;
};