/*
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of he MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 * 
 * This Source Code is part of the More-CPP CORE library.
 * https://www.more-cpp.com
 */
#pragma once

#include "../../exception.h"

#include <string>

/* unknown_interface_exception exception class */
class unknown_interface_exception : public core_exception_base_t
{
public:
	unknown_interface_exception(const std::string& type)
	{
		this->m_type = type;
	}

	virtual std::string to_string(void) const override
	{
		return "Unknown interface type \"" + this->m_type + "\" !";
	}

private:
	std::string m_type;
};

/* null interface exception class */
class null_interface_exception : public core_exception_base_t
{
public:
	virtual std::string to_string(void) const override
	{
		return "Invalid Interface !";
	}
};