/*
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of he MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 * 
 * This Source Code is part of the More-CPP CORE library.
 * https://www.more-cpp.com
 */
#include "../singleton_manager.h"

#include "manager.h"

#include "../interface/manager.h"

INITIALIZE_SINGLETON(core_arch_library_manager_t);
BIND_SINGLETON(core_arch_library_manager_t);

// detach all libraries
void core_arch_library_manager_t::detach_all(void)
{
	// detach all libraries
	core::get_instance<core_arch_interface_manager_t>()->detach_all();

	// clear all libraries
	this->m_libraries.clear();
}

// return current library name
extern "C" DLLEXPORT const char* get_library_name(void)
{
	return core::get_instance<core_arch_library_manager_t>()->get_name().c_str();
}
