/*
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of he MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 * 
 * This Source Code is part of the More-CPP CORE library.
 * https://www.more-cpp.com
 */
#pragma once

#include "../../utils/utils.h"
#include "../../resources/uid.h"
#include "../../utils/types/type.h"

#include <string>

namespace core::arch::message
{
	/* message base class */
	class base
	{
	public:
		// get specialized class type
		virtual std::string get_type_name(void) const
		{
			return get_instance<core_utils_types_manager_t>()->get_name_from_type(typeid(*this).name());
		}
	};
};

// shorthands
using core_arch_message_base_t = core::arch::message::base;
