/*
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of he MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 * 
 * This Source Code is part of the More-CPP CORE library.
 * https://www.more-cpp.com
 */
#pragma once

#include "ticket.h"

namespace core::arch::scope
{
	/* base class */
	class base
	{
	private:
		ticket m_ticket;

	public:

		// set alive flag to false on dtor
		virtual ~base(void) {}

		// return copy of scope ticket
		const ticket& get_scope_ticket(void) const
		{
			return this->m_ticket;
		}
	};
};

// shorthands
using core_arch_scope_base_t = core::arch::scope::base;