/*
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of he MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 * 
 * This Source Code is part of the More-CPP CORE library.
 * https://www.more-cpp.com
 */
#pragma once

#include "../exception.h"

// invalid_offset_exception exception class
class invalid_offset_exception : public core_exception_base_t
{
public:
	virtual std::string to_string(void) const override
	{
		return "Invalid offset!";
	}
};

// type_fit_exception exception class
class type_fit_exception : public core_exception_base_t
{
public:
	virtual std::string to_string(void) const override
	{
		return "type does not fit in available buffer space!";
	}
};

// buffer_read_exception exception class
class buffer_read_exception : public core_exception_base_t
{
public:
	virtual std::string to_string(void) const override
	{
		return "Erroneous buffer read exception!";
	}
};