/*
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of he MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 * 
 * This Source Code is part of the More-CPP CORE library.
 * https://www.more-cpp.com
 */
#pragma once

#include "logger/manager.h"

// macro to notify Events
#ifdef _MSC_VER

#define _event(type, file, line, szfmt, ...)     core::get_instance<core_debug_logger_manager_t>()->notify(type, file, line, core::format(szfmt, __VA_ARGS__))

#define _debug(szfmt, ...)		                 _event(core_debug_logger_event_type_t::DBG_MESSAGE, __FILE__, __LINE__, szfmt, __VA_ARGS__);
#define _warning(szfmt, ...)	                 _event(core_debug_logger_event_type_t::DBG_WARNING, __FILE__, __LINE__, szfmt, __VA_ARGS__);
#define _error(szfmt, ...)		                 _event(core_debug_logger_event_type_t::DBG_ERROR, __FILE__, __LINE__, szfmt, __VA_ARGS__);
#define _critical(szfmt, ...)	                 _event(core_debug_logger_event_type_t::DBG_CRITICAL, __FILE__, __LINE__, szfmt, __VA_ARGS__);

#else

#define _event(type, file, line, szfmt, ...)	 core::get_instance<core_debug_logger_manager_t>()->notify(type, file, line, core::format(szfmt __VA_OPT__(,) __VA_ARGS__))

#define _debug(szfmt, ...)		                 _event(core_debug_logger_event_type_t::DBG_MESSAGE, __FILE__, __LINE__, szfmt __VA_OPT__(,) __VA_ARGS__);
#define _warning(szfmt, ...)	                 _event(core_debug_logger_event_type_t::DBG_WARNING, __FILE__, __LINE__, szfmt __VA_OPT__(,) __VA_ARGS__);
#define _error(szfmt, ...)		                 _event(core_debug_logger_event_type_t::DBG_ERROR, __FILE__, __LINE__, szfmt __VA_OPT__(,) __VA_ARGS__);
#define _critical(szfmt, ...)	                 _event(core_debug_logger_event_type_t::DBG_CRITICAL, __FILE__, __LINE__, szfmt __VA_OPT__(,) __VA_ARGS__);

#endif