/*
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of he MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 * 
 * This Source Code is part of the More-CPP CORE library.
 * https://www.more-cpp.com
 */
#pragma once

#include "../../../exception.h"
#include "../../../data/buffer.h"

#include "../base.h"
#include "../encode.h"

namespace core::resources::filesystem::spc0
{
	// version
	static constexpr uint32_t IDENT_VERSION = 'SPC0';

	// header structure
#pragma pack(push, 8)
	struct header_s
	{
		uint32_t ident;
		uint32_t checksum;

		uint64_t num_buffers;
		uint64_t buffers_table_offset;

		uint32_t seed;

		uint64_t buffers_data_offset;

		uint32_t _reserved[10];
	};

	struct buffer_s
	{
		unsigned char encoding;
		uint64_t offset;
		uint64_t size;
	};
#pragma pack(pop)			
};
