/*
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of he MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 * 
 * This Source Code is part of the More-CPP CORE library.
 * https://www.more-cpp.com
 */
#pragma once

#include "../../utils/utils.h"

#include "../../exception.h"

#include <string>

/* null_job_exception exception class */
class null_job_exception : public core_exception_base_t
{
public:
	virtual std::string to_string(void) const override
	{
		return "Invalid job!";
	}
};


/* job_done_exception exception class */
class job_done_exception : public core_exception_base_t
{
public:
	virtual std::string to_string(void) const override
	{
		return "Job is not done yet!";
	}
};

/* job_adopt_exception exception class */
class job_adopt_exception : public core_exception_base_t
{
public:
	virtual std::string to_string(void) const override
	{
		return "Cannot adopt job!";
	}
};

/* job_release_exception exception class */
class job_release_exception : public core_exception_base_t
{
public:
	virtual std::string to_string(void) const override
	{
		return "Cannot release job!";
	}
};

/* job_add_exception exception class */
class job_add_exception : public core_exception_base_t
{
public:
	virtual std::string to_string(void) const override
	{
		return "Cannot add job!";
	}

};

/* job_queue_exception exception class */
class job_queue_exception : public core_exception_base_t
{
public:
	virtual std::string to_string(void) const override
	{
		return "Cannot queue job!";
	}
};

/* job_exception exception class */
class job_exception : public core_exception_base_t
{
public:
	job_exception(const std::string& message)
	{
		this->m_message = message;
	}

	virtual std::string to_string(void) const override
	{
		return "job finished with error \"" + this->m_message + "\" !";
	}

private:
	std::string m_message;
};
