/*
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of he MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 * 
 * This Source Code is part of the More-CPP CORE library.
 * https://www.more-cpp.com
 */
#include "../../arch/singleton.h"
#include "../pool/manager.h"
#include "manager.h"

INITIALIZE_SINGLETON(core_threads_jobs_manager_t)

// disptach job
void core_threads_jobs_manager_t::disptach(std::shared_ptr<core_threads_jobs_base_t> p)
{
	if (p != nullptr)
		core::get_instance<core_threads_pool_manager_t>()->queue(p);

	_debug("current thread pool capacity: %d", core::get_instance<core_threads_pool_manager_t>()->get_capacity());
}