/*
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of he MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 * 
 * This Source Code is part of the More-CPP CORE library.
 * https://www.more-cpp.com
 */
#pragma once

#include <mutex>

// shorthand for mutex type
using lock_t = std::mutex;

 // lock mutex in scope
#define AUTOLOCK_EX(handle, type)	std::lock_guard<type> lock##__LINE__(handle);

#define AUTOLOCK(handle)			AUTOLOCK_EX(handle, std::mutex)