/*
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of he MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 * 
 * This Source Code is part of the More-CPP CORE library.
 * https://www.more-cpp.com
 */
#pragma once

#ifdef UNIX

#include <csignal>
#include <unistd.h>
#include <sys/socket.h>

using SOCKET = int;
using SOCKADDR = struct sockaddr;

constexpr int SOCKET_ERROR = -1;
constexpr SOCKET INVALID_SOCKET = -1;

inline void __debugbreak(void)
{
	raise(SIGTRAP);
}

inline void closesocket(SOCKET socket)
{
	shutdown(socket, SHUT_RDWR);
	close(socket);
}

#endif