/*
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of he MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 * 
 * This Source Code is part of the More-CPP CORE library.
 * https://www.more-cpp.com
 */
#pragma once

#include "../utils.h"

#include "../../debug/log.h"

#include "exception.h"
#include "test.h"

#include <cstdlib>
#include <cstring>

namespace core
{
	// expect boolean
	static void expect_bool(const std::string& label, bool value1, bool value2)
	{
		// check for success
		bool success = value1 == value2;

		// display success and exit
		if (success)
		{
			_success("%s\tis ok", label.c_str());

			return;
		}

		// display failure
		_failure("%s\t\"%s\" is NOT \"%s\"", label.c_str(), value1 ? "true" : "false", value2 ? "true" : "false");

		// throw exception
		throw_exception(test_failed_exception);
	}
};

#define EXPECT_BOOL(label, value1, value2)		core::expect_bool(label, value1, value2);
#define EXPECT_TRUE(label, value)				core::expect_bool(label, value, true);
#define EXPECT_FALSE(label, value)				core::expect_bool(label, value, false);