#!/bin/bash

# define additional flags for makefile
export INCL_CPP_FLAGS="-fprofile-arcs -ftest-coverage -L /usr/lib -I/usr/include"

# clear all gcno files
find ./ -name "*.gcov" -exec rm -f {} \;
find ./ -name "*.gcno" -exec rm -f {} \;
find ./ -name "*.gcda" -exec rm -f {} \;

rm -f coverage.info

# make again
make clean
make

# run test coverage
./app-test

if [ $? -ne 0 ]
then
	echo "program ended with errors" 1&>2

	exit 1
fi

gcov ./apps/test-app/main.cpp
lcov -c --directory . --output-file coverage.info --include "$(pwd)/common/*" --exclude "$(pwd)/common/utils/test/*" --exclude "*/exception.h"
genhtml coverage.info --output-directory coverage

# generate xml file
# gcovr --xml-pretty --exclude "$(pwd)/common/utils/test/*" --filter "$(pwd)/common/*" --exclude-unreachable-branches --print-summary -o coverage.xml

exit 0
