/*
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of he MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 * 
 * This Source Code is part of the More-CPP CORE library.
 * https://www.more-cpp.com
 */
#include "../test-common/common.h"

/* sample remote module */
class core_storage_remote_mockup : public core_storage_module
{
public:
	IMPLEMENT_STORAGE;

	core_storage_remote_mockup(void)
	{
		this->m_data = 0;
	}

	void set(int data)
	{
		this->m_data = data;
	}

	const int get(void) const
	{
		return this->m_data;
	}

private:
	int m_data;
};

BEGIN_STORAGE(core_storage_remote_mockup)
{
	DECLARE_STORAGE(core_storage_remote_mockup, m_data),
} END_STORAGE(core_storage_remote_mockup, core_storage_remote_mockup);

DECLARE_INSTANCEABLE_OBJECT(core_storage_remote_mockup, core_storage_module);