/*
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of he MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 * 
 * This Source Code is part of the More-CPP CORE library.
 * https://www.more-cpp.com
 */
#include <stdio.h>

#include "../../../common/utils/utils.h"
#include "../../../common/exception.h"
#include "../../../common/utils/test/test.h"

/* mockup_exception exception class */
class core_debug_mockup_exception : public core_exception_base_t
{
public:
	virtual std::string to_string(void) const
	{
		return "mock up exception";
	}
};

/* exception test */
class core_debug_exception_test : public core_utils_test_base_t
{
public:
	virtual void run(void) const override
	{
		_comment("Exception Tests");

		// throw_exception shall do its job
		EXPECT_EXCEPTION("throw_exception shall always throw an exception", [&](void)
			{
				throw_exception(core_debug_mockup_exception);
			});
	}
};

REGISTER_TEST(core_debug_exception_test);