/*
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of he MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 * 
 * This Source Code is part of the More-CPP CORE library.
 * https://www.more-cpp.com
 */
#include "../../common/utils/utils.h"
#include "../../common/arch/library/manager.h"

#ifdef _WIN32
#include <windows.h>
#endif

#include <filesystem>

#define LIBNAME	"core-tests"

// dll attach
void CONSTRUCTOR dll_attach(void)
{
	core::get_instance<core_arch_library_manager_t>()->set_name(LIBNAME);
}

// dll detach
void DESTRUCTOR dll_detach(void)
{
	// remove temporary file
	std::filesystem::remove("test.txt");
}

// dll entry point
#ifdef _WIN32

BOOL APIENTRY DllMain(HMODULE hModule, DWORD  ul_reason_for_call, LPVOID lpReserved)
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
		dll_attach();
		break;

	case DLL_PROCESS_DETACH:
		dll_detach();
		break;
	}

	return TRUE;
}

#endif
