/*
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of he MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 * 
 * This Source Code is part of the More-CPP CORE library.
 * https://www.more-cpp.com
 */
#pragma once

#include "../../../common/data/buffer.h"
#include "../../../common/resources/async_proxy.h"

#include <stdlib.h>

extern int g_num_loads;

class core_resources_intval
{
public:
	core_resources_intval(int val = 0)
	{
		this->m_value = val;
	}

	core_resources_intval(const core_data_buffer_t& data) : core_resources_intval(0)
	{
		// slow to construct
		std::this_thread::sleep_for(std::chrono::duration<double, std::ratio<1>>(0.1));

		// construct
		this->m_value = (int)atol(data.ptr<char>(0));

		g_num_loads++;
	}

	void set(const int val)
	{
		this->m_value = val;
	}

	const int& get(void) const
	{
		return this->m_value;
	}

private:
	int m_value;
};

using core_resources_intval_async_resource_t = core_resources_async_proxy_t<core_resources_intval>;