/*
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of he MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 * 
 * This Source Code is part of the More-CPP CORE library.
 * https://www.more-cpp.com
 */
#include <stdio.h>

#include "../../../common/utils/utils.h"
#include "../../../common/exception.h"
#include "../../../common/utils/test/test.h"
#include "../../../common/resources/proxy.h"

#include "core_resources_intval.h"

/* Name Test */
class core_resources_name_test : public core_utils_test_base_t
{
public:
	virtual void run(void) const override
	{
		_comment("Resources Name Test");

		const char* resname = "string://10";

		core_resources_proxy_t<core_resources_intval> r(resname);

		EXPECT_STR("Resource has correct name", r.name(), resname);
	}
};

REGISTER_TEST(core_resources_name_test);