/*
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of he MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 * 
 * This Source Code is part of the More-CPP CORE library.
 * https://www.more-cpp.com
 */
#pragma once

#include "../../../common/resources/storage/base.h"
#include "../../../common/resources/async_proxy.h"

#include "core_resources_intval.h"

class core_resources_embedded_sample : public core_resources_storage_base_t
{
public:
	IMPLEMENT_STORAGE;

public:
	core_resources_embedded_sample(void) {}

	core_resources_embedded_sample(const std::string& resource)
	{
		this->m_res = core_resources_intval_async_resource_t(resource);
		
		// wait for synchronization
		this->m_res.wait();
	}

	int eval(void) const
	{
		this->m_res.wait();

		return this->m_res->get();
	}

private:
	core_resources_intval_async_resource_t m_res;
};

class core_resources_derived_sample : public core_resources_intval_async_resource_t
{
public:
	IMPLEMENT_STORAGE;

public:
	core_resources_derived_sample(void)
	{
		this->m_other = 0;
	}

	core_resources_derived_sample(const std::string& resource, int other) : core_resources_intval_async_resource_t(resource)
	{
		this->m_other = other;

		// wait for synchronization
		this->wait();
	}

	int eval(void) const
	{
		this->wait();

		return this->ptr()->get();
	}

	int other(void) const
	{
		return this->m_other;
	}

private:
	int m_other;
};
