/*
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of he MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 * 
 * This Source Code is part of the More-CPP CORE library.
 * https://www.more-cpp.com
 */
#include "../../../common/utils/utils.h"
#include "../../../common/exception.h"
#include "../../../common/data/buffer.h"
#include "../../../common/resources/storage/container.h"
#include "../../../common/utils/types/type.h"
#include "../../../common/utils/test/test.h"

#include "../../test-common/common.h"

#include "core_storage_mockup.h"

/* storage file tests */
class core_storage_file_test : public core_utils_test_base_t
{
public:
	virtual void run(void) const override
	{
		_comment("Storage file tests");

		// unknown file type exception
		{
			// create instance
			auto p = core::create_instance<core_storage_module>("core_storage_mockup");

			// storage object
			core_resources_storage_container_t container;
			container.push_back(p);

			EXPECT_EXCEPTION("unknow file type shall trigger exception", [&](void)
				{
					auto buffer = container.pack('0000');
				});
		}
	}
};

REGISTER_TEST(core_storage_file_test);