/*
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of he MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 * 
 * This Source Code is part of the More-CPP CORE library.
 * https://www.more-cpp.com
 */
#pragma once

#include "../../common/utils/utils.h"
#include "../../common/arch/interface/base.h"
#include "../../common/resources/storage/base.h"
#include "../../common/arch/instancers/instancer.h"
#include "../../common/threads/jobs/base.h"

/* sample interface */
class core_arch_interface_mockup : public core_arch_interface_base_t
{
public:
	virtual int test(void) const = 0;
};

/* base class */
class core_arch_instancer_base_mockup : public core_arch_instancer_object_base_t<core_arch_instancer_base_mockup>
{
public:
	virtual int get(void) const
	{
		return 0;
	}
};

// remote module interface
class core_storage_module : public core_resources_storage_base_t, public core_arch_instancer_object_base_t<core_storage_module>
{
public:
	IMPLEMENT_STORAGE;

	core_storage_module(void) {}

	virtual void set(int data) = 0;
	virtual const int get(void) const = 0;
};